; (* Facilities for dynamically allocating and deallocating storage *)
GLOBAL Storage_BEGIN
GLOBAL Storage_ALLOCATE
GLOBAL Storage_DEALLOCATE

SECTION .text
; ---------------------------------------------------------------------------- ;
Storage_BEGIN:
        push   ebx
        ; push   esi
        ; push   edi

; heap.initialize
        mov    eax, 68
        mov    ebx, 11
        int    64

        ; pop    edi
        ; pop    esi
        pop    ebx

        ret
; ---------------------------------------------------------------------------- ;
; PROCEDURE ALLOCATE (VAR addr: SYSTEM.ADDRESS; amount: CARDINAL);
;   (* Allocates storage for a variable of size amount and assigns the address of this
;      variable to addr. If there is insufficient unallocated storage to do this, the
;      value NIL is assigned to addr.
;   *)
Storage_ALLOCATE:
        push   ebx
        ; push   esi
        ; push   edi

        mov    eax, 68
        mov    ebx, 12
        mov    ecx, [esp + 8 + 1*4]
        int    64

        mov    ecx, [esp + 4 + 1*4]
        mov   [ecx], eax

        ; pop    edi
        ; pop    esi
        pop    ebx

        ret    8
; ---------------------------------------------------------------------------- ;
; PROCEDURE DEALLOCATE (VAR addr: SYSTEM.ADDRESS; amount: CARDINAL);
;   (* Deallocates amount locations allocated by ALLOCATE for the storage of the variable
;      addressed by addr and assigns the value NIL to addr.
;   *)
Storage_DEALLOCATE:
        push   ebx
        ; push   esi
        ; push   edi

        mov    eax, 68
        mov    ebx, 13
        mov    ecx, [esp + 4 + 1*4]
        mov    ecx, [ecx]
        int    64

        mov    ecx, [esp + 4 + 1*4]
        mov   [ecx], dword 0

        ; pop    edi
        ; pop    esi
        pop    ebx

        ret    8